#include	<stdio.h>
#include	<fcntl.h>
#include	<dtm.h>
#include	<sds.h>
#include	"DScope.h"

#define DEBUG	1

#ifdef DEBUG
FILE * outfile;
#endif
char	version[] = "version ALPHA test";

int	done = 0;


main(argc, argv)
  int	argc;
  char	*argv[];
{
  int	bytes2read;
  int	inport, outport;
  char	header[DTM_MAX_HEADER];
  char	addr[64];
  int	i;
  scope_array lft,rft,ans;
  float max, min;

  /* make input port */
  inport = DTMmakeInPort(":0"); 	/* system will assign tcp port */

#ifdef DEBUG
outfile = fopen ("testfile", "a+");
fprintf (outfile, "got inport\n");
fclose (outfile);
#endif

  /* parse command line */
  for (i=1; i<argc; i+=1)			/* look for output port */
    if (!strncmp(argv[i], "-DTM", 4))		/* specified on command line */
	{
      outport = DTMmakeOutPort(argv[i+1]);	/* by invoking process */


  /* get the address of input port */

#ifdef DEBUG
outfile = fopen ("testfile", "a+");
fprintf (outfile, "got outport %d\n",outport);
fprintf (outfile, "argv = %s\n",argv[i+1]);
fclose (outfile);
#endif
	}

  DTMgetPortAddr(inport, addr, sizeof addr);	/* address = "hostname:port" */

#ifdef DEBUG
outfile = fopen ("testfile", "a+");
fprintf (outfile, "inport address %s\n",addr);
fclose (outfile);
#endif

  /* make message with inport address */
  DTMsetClass(header, "DTM ");			/* message =  */
  strcat(header, addr);				/*      "DTM hostname:port" */
  strcat(header, " ");

  /* write inport address to invoking process */
  DTMbeginWrite(outport, addr, strlen(addr)+1);
  DTMendWrite(outport);				/* no data in this message */

#ifdef DEBUG
outfile = fopen ("testfile", "a+");
fprintf (outfile, "wrote inport address : %s\n",addr);
fclose (outfile);
#endif 

  /* write version -- optional */
  DTMsetClass(header, MSGclass);
  strcat(header, version);

  DTMbeginWrite(outport, header, DTMheaderLength(header));
  DTMendWrite(outport);


  /*******************************************************************/
  /* At this point 2 ports have been established between Image 3.0   */
  /* and the application.  Image 3.0 will automatically send any     */
  /* data sets specified with the startDTM command.  After the data  */
  /* sets have been sent the user may type commands.                 */
  /*******************************************************************/



  /* read the message header */
  while ((bytes2read = DTMavailRead(inport)) == 0);

  /* was there a DTM error? */
  if (bytes2read == DTMERROR)
    exit (1);

  /* read the data. */
  if (DTMbeginRead(inport, header, DTM_MAX_HEADER) == DTMERROR) {
     exit(-1);
  }

#ifdef DEBUG
outfile = fopen ("testfile", "a+");
fprintf (outfile, "reading data set\n",addr);
fclose (outfile);
#endif

      /************************************************************/
      /* Message-level multiplexing -                             */
      /* The header of the message has been received,             */
      /* decide what to do next based on the class of the message */
      /************************************************************/


  /* receive a Multi-Dimensional Data set */
  if (SDScompareClass(header))
    read_SDS(inport, header,&lft);
    
  /* look for command message */
  else if (!MSGcompareClass(header)) 

#ifdef DEBUG
outfile = fopen ("testfile", "a+");
fprintf(outfile, "Unknown message received.\n");
fclose (outfile);
#endif
         
  /* end of message */
  DTMendRead(inport);

#ifdef DEBUG
outfile = fopen ("testfile", "a+");
fprintf(outfile, "Done reading: dims = %d %d\n",lft.nrows, lft.ncols);
fclose (outfile);
#endif

  rft.kind = DS_CONSTANT;
  /* find the max and min of lft. */

  for (min = max = *(lft.vals), i = 1; i < lft.nrows*lft.ncols;i++)
    {
    if (min > lft.vals[i]) min = lft.vals[i];
    if (max < lft.vals[i]) max = lft.vals[i];
    }

  rft.cval = min + ((max-min)/2);
  ans.kind = DS_ARRAY;
  ans.vals = (float *) malloc (sizeof (float) * lft.nrows * lft.ncols);
  ans.nrows = lft.nrows;
  ans.ncols = lft.ncols;

#ifdef DEBUG
outfile = fopen ("testfile", "a+");
fprintf(outfile, "hifilter\n");
fprintf(outfile, "before hifilter:ans dims = %d %d\n",ans.nrows,ans.ncols);
fclose (outfile);
#endif

  exhifilter (&lft, &rft, &ans);

#ifdef DEBUG
outfile = fopen ("testfile", "a+");
fprintf(outfile, "after:ans dims = %d %d\n",ans.nrows,ans.ncols);
fprintf(outfile, "hifilter done\n");
fclose (outfile);
#endif

  send_SDS (outport,&ans);

#ifdef DEBUG
outfile = fopen ("testfile", "a+");
fprintf(outfile, "DONE\n");
fclose (outfile);
#endif
}

/*************************************************************************
**
**  Example routine -
**    read a Multi-Dimensional Data set from a port
**
*************************************************************************/
read_SDS (port, header, lft)
  int	port;
  char	*header;
  scope_array *lft;
 
{
  int		i, rank, dims[10], size;
  DTMTYPE	mdd_type;
  float		*mdd;

#ifdef DEBUG
outfile = fopen ("testfile", "a+");
fprintf(outfile, "header = '%s'\n",header);
fclose (outfile);
#endif

  SDSgetType(header, &mdd_type);

  if (mdd_type != DTM_FLOAT)  {
#ifdef DEBUG
outfile = fopen ("testfile", "a+");
fprintf(outfile, "type not dtm float!",header);
fclose (outfile);
#endif
    return -1;
    }

  SDSgetDimensions(header, &rank, dims, sizeof (dims));
  size = SDSnumElements(rank, dims);

  if ((mdd = (float *)malloc(size * sizeof (float))) == NULL)  {
    return -1;
    }

  DTMreadDataset(port, mdd, size, DTM_FLOAT);

  lft->kind = DS_ARRAY;
  lft->vals = mdd;
  lft->ncols = dims[0];
  lft->nrows = dims[1];

  lft->cols = (float *) malloc (dims[0] * sizeof(float));
  for (i = 0; i < dims[0]; i++) lft->cols[i] = i;
  lft->rows = (float *) malloc (dims[1] *  sizeof(float));
  for (i = 0; i < dims[1]; i++) lft->rows[i] = i;
 
  return 0;
}
  


/*************************************************************************
**
**  Example routine -
**    Writes a Multi-Dimensional Data set
**
*************************************************************************/
send_SDS(port, ans)
  int	port;
  scope_array *ans;
{
  int	rank, dims[2];
  char	h[SDSsize];


  /* sample parameters */
  rank = 2;
  dims[0] = ans->nrows; dims[1] = ans->ncols;

  /* create header for MDD */
  SDSsetClass(h);
  SDSsetTitle(h, "TITLE ");
  SDSsetDimensions(h, rank, dims);
  SDSsetType(h, DTM_FLOAT);

  /* send MDD */
  DTMbeginWrite(port, h, SDSheaderLength(h));
  DTMsendDataset(port, ans->vals, dims[0] * dims[1], DTM_FLOAT);
  DTMendWrite(port);
}
  

